/*
   Page 11 of
   http://pages.cs.wisc.edu/~remzi/OSTEP/threads-cv.pdf

   Figure 30.10: Producer/Consumer: Two CVs And While
*/
#include <windows.h>  // needed for Sleep()
#include <stdio.h>
#include "mythreads.h"
#include "figure_30.4.h"

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t  empty = PTHREAD_COND_INITIALIZER;
pthread_cond_t   fill = PTHREAD_COND_INITIALIZER;

void *producer(void *arg)
{
   int i;
   int loops = (int) arg;   /*** author forgot this ***/
   for (i = 0; i < loops; i++)
   {
      Pthread_mutex_lock(&mutex);
      while (count == 1)
         pthread_cond_wait(&empty, &mutex);
      put(i);
      pthread_cond_signal(&fill);
      Pthread_mutex_unlock(&mutex);
   }
   return NULL; /*** author forgot this ***/
}

void *consumer(void *arg)
{
 //int i;  /*** not needed ***/
   while (1)
   {
      Pthread_mutex_lock(&mutex);
      while (count == 0)
         pthread_cond_wait(&fill, &mutex);
      int tmp = get();
      pthread_cond_signal(&empty);
      Pthread_mutex_unlock(&mutex);
      printf("%d\n", tmp); /*** Why is this outside the critical section? ***/
   }
}


int
main( )
{
   pthread_t p1, p2;
   printf("main: begin\n");
   Pthread_create(&p1, NULL, producer, (void*)20);
   Pthread_create(&p2, NULL, consumer, NULL);
   Pthread_create(&p2, NULL, consumer, NULL);  /* see page 8 */
   // join waits for the producer to finish
   Pthread_join(p1, NULL);
   // let the consumers empty the buffer
   Sleep(500); // Win32
   printf("main: end\n");
   return 0;
}
