/*
   Page 3 of
   http://pages.cs.wisc.edu/~remzi/OSTEP/threads-cv.pdf

   Figure 30.3: Parent Waiting For Child: Use A Condition Variable
*/
#include <stdio.h>
#include "mythreads.h"

int done = 0;
pthread_mutex_t m = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t  c = PTHREAD_COND_INITIALIZER;

void thr_exit()
{
   Pthread_mutex_lock(&m);
   done = 1;
   pthread_cond_signal(&c);
   Pthread_mutex_unlock(&m);
}

void *child(void *arg)
{
   printf("child\n");
   thr_exit();
   return NULL;
}

void thr_join()
{
   Pthread_mutex_lock(&m);
   while (done == 0)
      pthread_cond_wait(&c, &m);
   Pthread_mutex_unlock(&m);
}

int main( )
{
   printf("parent: begin\n");
   pthread_t p;
   Pthread_create(&p, NULL, child, NULL);
   thr_join();
   printf("parent: end\n");
   return 0;
}
