/*
   Page 7 of
   http://pages.cs.wisc.edu/~remzi/OSTEP/threads-cv.pdf

   Figure 30.6: Producer/Consumer: Single CV And If Statement
*/
#include <windows.h>  // needed for Sleep()
#include <stdio.h>
#include "mythreads.h"
#include "figure_30.4.h"

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t   cond = PTHREAD_COND_INITIALIZER;

void *producer(void *arg)
{
   int i;
   int loops = (int) arg;   /*** author forgot this ***/
   for (i = 0; i < loops; i++)
   {
      Pthread_mutex_lock(&mutex);          // p1
      if (count == 1)                      // p2
         pthread_cond_wait(&cond, &mutex); // p3
      put(i);                              // p4
      pthread_cond_signal(&cond);          // p5
      Pthread_mutex_unlock(&mutex);        // p6
   }
   return NULL; /*** author forgot this ***/
}

void *consumer(void *arg)
{
 //int i;  /*** not needed ***/
   while (1)
   {
      Pthread_mutex_lock(&mutex);          // c1
      if (count == 0)                      // c2
         pthread_cond_wait(&cond, &mutex); // c3
      int tmp = get();                     // c4
      pthread_cond_signal(&cond);          // c5
      Pthread_mutex_unlock(&mutex);        // c6
      printf("%d\n", tmp);
   }
}


int
main( )
{
   pthread_t p1, p2;
   printf("main: begin\n");
   Pthread_create(&p1, NULL, producer, (void*)20);
   Pthread_create(&p2, NULL, consumer, NULL);
   Pthread_create(&p2, NULL, consumer, NULL);  /* see page 8 */
   // join waits for the producer to finish
   Pthread_join(p1, NULL);
   // let the consumer empty the buffer
   Sleep(500); // Win32
   printf("main: end\n");
   return 0;
}
